config/routes.rb
Rails.application.routes.draw do
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Reveal health status on /up that returns 200 if the app boots with no exceptions, otherwise 500.
  # Can be used by load balancers and uptime monitors to verify that the app is live.
  get "up" => "rails/health#show", as: :rails_health_check

  # Defines the root path route ("/")
  # root "posts#index"
  root 'pages#home'
  get 'about', to: 'pages#about'
  resources :articles, only: [:show, :index, :new, :create, :edit, :update, :destroy]
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/article.rb
class Article < ApplicationRecord
    validates :title, presence: true, length: { minimum: 6, maximum: 100 }
    validates :description, presence: true, length: { minimum: 10, maximum: 300 }
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/articles_controller.rb
class ArticlesController < ApplicationController
    before_action :set_article, only: [:show, :edit, :update, :destroy]

    def show        
    end

    def index
        @articles = Article.all
    end

    def new
        @article = Article.new
    end

    def edit        
    end

    def create
        @article = Article.new(article_params)
        if @article.save
            flash[:notice] = "Article was created successfuly."
            redirect_to @article
        else
            render :new, status: :unprocessable_entity
        end
    end

    def update        
        if @article.update(article_params)
            flash[:notice] = "Article was updated successfuly."
            redirect_to @article
        else
            render :new, status: :unprocessable_entity
        end
    end

    def destroy        
        @article.destroy
        redirect_to articles_path
    end

    private

    def set_article
        @article = Article.find(params[:id])
    end

    def article_params
        params.require(:article).permit(:title, :description)
    end

end

app/controllers/pages_controller.rb
class PagesController < ApplicationController
    def home
    end

    def about
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/pages_helper.rb
module PagesHelper
end

app/views/articles/_form.html.erb
<%= form_with(model: @article, local: true) do |f| %>
    <p>
        <%= f.label :title %><br/>
        <%= f.text_field :title %>
    </p>
    <p>
       <%= f.label :description %><br/>
       <%= f.text_area :description %>
    </p>

    <p>
        <%= f.submit %>
    </p>
<% end %>

app/views/articles/_form_error.html.erb
<% if @article.errors.any? %>
<h2>The folowing errors prevented the article from being saved:</h2>
<ul>
    <% @article.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
    <% end %>
</ul>
<% end %>

app/views/articles/edit.html.erb
<h1>Edit article</h1>

<%= render 'form_error' %>
<%= render 'form' %>

<%= link_to 'Cancel and return to articles listing', articles_path %>

app/views/articles/index.html.erb
<h1>Articles listing page</h1>

<table>
    <thead>
        <tr>
            <th>Title</th>
            <th>Description</th>
            <th colspan="3">Actions</th>
        </tr>
    </thead>
    <tbody>
        <% @articles.each do |article| %>
        <tr>
            <td><%= article.title %></td>
            <td><%= article.description %></td>
            <td><%= link_to 'Show', article_path(article) %></td>
            <td><%= link_to 'Edit', edit_article_path(article) %></td>
            <td><%= link_to 'Delete', article_path(article), data: { turbo_method: :delete, turbo_confirm: "Are you sure?" } %></td>
        </tr>
        <% end %>
    </tbody>
</table>
<p>
    <%= link_to 'Create new article', new_article_path %>
</p>

app/views/articles/new.html.erb
<h1>Create a new article</h1>

<%= render 'form_error' %>
<%= render 'form' %>

<%= link_to 'Return to articles listing', articles_path %>

app/views/articles/show.html.erb
<h1>Showing article details</h1>
<p><strong>Title: </strong><%= @article.title %></p>
<p><strong>Description: </strong><%= @article.description %></p>

<%= link_to 'Edit', edit_article_path(@article) %> |
<%= link_to 'Delete', article_path(@article), data: { turbo_method: :delete, turbo_confirm: "Are you sure?" } %> |
<%= link_to 'Return to articles listing', articles_path %>

app/views/layouts/_messages.html.erb
<% flash.each do |name, msg| %>
    <%= msg %>
<% end %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>AlphaBlog</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <%= render 'layouts/messages' %>
    <%= yield %>
  </body>
</html>

app/views/pages/about.html.erb
<h1>This is an About page</h1>

<%= link_to 'Articles listing', articles_path %> |
<%= link_to 'Home page', root_path %>

app/views/pages/home.html.erb
<h1>This is Home/Default page</h1>

<%= link_to 'Articles listing', articles_path %> |
<%= link_to 'About page', about_path %>